## rr 1.0

=== DESCRIPTION ===
Package: rr
Version: 1.0
Date: 2015-2-7
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
Maintainer: Graeme Blair <graeme.blair@columbia.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS (>= 7.3), arm (>= 1.7-07), coda (>= 0.16-1)
Description: Enables researchers to conduct multivariate statistical analyses of survey data with randomized response technique items from several designs, including mirrored question, forced question, and unrelated question. This includes regression with the randomized response as the outcome and logistic regression with the randomized response item as a predictor. In addition, tools for conducting power analysis for designing randomized response items are included. The package implements methods described in Blair, Imai, and Zhou (2015) ''Design and Analysis of the Randomized Response Technique,'' Working paper available at <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 2)
Packaged: 2015-02-07 10:50:30 UTC; gblair
NeedsCompilation: yes
Repository: CRAN
Date/Publication: 2015-02-08 01:05:46
