## rr 1.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Package: rr
-Version: 1.1
-Date: 2015-2-19
+Version: 1.2
+Date: 2015-3-9
 Title: Statistical Methods for the Randomized Response Technique
 Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
 Maintainer: Graeme Blair <graeme.blair@columbia.edu>
@@ -10,7 +10,8 @@
 LazyLoad: yes
 LazyData: yes
 License: GPL (>= 2)
-Packaged: 2015-02-19 03:33:42 UTC; gblair
+Suggests: testthat
+Packaged: 2015-03-21 16:04:03 UTC; gblair
 NeedsCompilation: yes
 Repository: CRAN
-Date/Publication: 2015-02-19 08:01:47
+Date/Publication: 2015-03-21 19:28:56
