## rr 1.3.1

=== DESCRIPTION ===
Package: rr
Version: 1.3.1
Date: 2016-5-13
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair <graeme.blair@columbia.edu>, Yang-Yang Zhou
    <yz3@princeton.edu>, Kosuke Imai <kimai@princeton.edu>
Maintainer: Graeme Blair <graeme.blair@columbia.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Working
    paper available at <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-05-15 07:40:49 UTC; ligges
Repository: CRAN
Date/Publication: 2016-05-15 09:40:49
