## rr 1.4

=== DESCRIPTION ===
Package: rr
Version: 1.4
Date: 2016-8-15
Title: Statistical Methods for the Randomized Response Technique
Author: Graeme Blair [aut, cre], Yang-Yang Zhou [aut, cre], 
    Kosuke Imai [aut, cre], Winston Chou [ctb]
Maintainer: Graeme Blair <graeme.blair@ucla.edu>
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda, magic
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Journal
    of the American Statistical Association 
    <http://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
RoxygenNote: 5.0.1
NeedsCompilation: yes
Packaged: 2016-08-16 01:24:11 UTC; gblair
Repository: CRAN
Date/Publication: 2016-08-17 00:49:19
