## rr 1.4.1

=== DESCRIPTION ===
Package: rr
Version: 1.4.1
Title: Statistical Methods for the Randomized Response Technique
Authors@R: c(person("Graeme", "Blair", email = "graeme.blair@gmail.com", role = c("aut", "cre")),
             person("Yang-Yang", "Zhou", email = "yangyang.zhou@ubc.ca", role = c("aut")),
             person("Kosuke", "Imai", email = "imai@harvard.edu", role = c("aut")),
             person("Winston", "Chou", email = "wchou@princeton.edu", role = c("ctb")))
Depends: R (>= 3.0.0), utils
Imports: MASS, arm, coda, magic
Description: Enables researchers to conduct multivariate statistical analyses
    of survey data with randomized response technique items from several designs,
    including mirrored question, forced question, and unrelated question. This
    includes regression with the randomized response as the outcome and logistic
    regression with the randomized response item as a predictor. In addition,
    tools for conducting power analysis for designing randomized response items
    are included. The package implements methods described in Blair, Imai, and Zhou
    (2015) ''Design and Analysis of the Randomized Response Technique,'' Journal
    of the American Statistical Association 
    <https://graemeblair.com/papers/randresp.pdf>.
LazyLoad: yes
LazyData: yes
License: GPL (>= 3)
Suggests: testthat
Encoding: UTF-8
RoxygenNote: 7.1.2
NeedsCompilation: yes
Packaged: 2022-05-24 02:06:48 UTC; gdblair
Author: Graeme Blair [aut, cre],
  Yang-Yang Zhou [aut],
  Kosuke Imai [aut],
  Winston Chou [ctb]
Maintainer: Graeme Blair <graeme.blair@gmail.com>
Repository: CRAN
Date/Publication: 2022-05-24 10:10:02 UTC
