## rr 1.4.2

=== DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: rr
-Version: 1.4.1
+Version: 1.4.2
 Title: Statistical Methods for the Randomized Response Technique
 Authors@R: c(person("Graeme", "Blair", email = "graeme.blair@gmail.com", role = c("aut", "cre")),
              person("Yang-Yang", "Zhou", email = "yangyang.zhou@ubc.ca", role = c("aut")),
@@ -22,13 +22,13 @@
 License: GPL (>= 3)
 Suggests: testthat
 Encoding: UTF-8
-RoxygenNote: 7.1.2
+RoxygenNote: 7.2.3
 NeedsCompilation: yes
-Packaged: 2022-05-24 02:06:48 UTC; gdblair
+Packaged: 2024-01-16 06:17:35 UTC; gblair
 Author: Graeme Blair [aut, cre],
   Yang-Yang Zhou [aut],
   Kosuke Imai [aut],
   Winston Chou [ctb]
 Maintainer: Graeme Blair <graeme.blair@gmail.com>
 Repository: CRAN
-Date/Publication: 2022-05-24 10:10:02 UTC
+Date/Publication: 2024-01-16 11:20:02 UTC
