=== debian/changelog ===
rr (2.0.0-1) unstable; urgency=medium

  * New upstream release.
  * doc/rr.pdf is no longer shipped upstream, there is no need to filter
    it in debian/copyright.
  * Westmere and Haswell support is no longer experimental, update the
    description accordingly.
  * rr now needs zlib to build.
  * Add bash-location.patch to fix the bash location in signal-rr-
    recording.sh.
  * Install signal-rr-recording.sh as signal-rr-recording.

 -- Stephen Kitt <skitt@debian.org>  Tue, 09 Sep 2014 00:15:39 +0200

rr (1.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 13 Aug 2014 00:02:14 +0200

rr (1.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Tue, 12 Aug 2014 23:57:01 +0200

rr (1.3.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Sun, 04 May 2014 20:52:07 +0200

rr (1.2.1+dfsg-1) unstable; urgency=low

  * Initial release (closes: #742556).

 -- Stephen Kitt <skitt@debian.org>  Fri, 18 Apr 2014 06:43:45 +0200
