=== debian/control ===
Source: rr
Section: devel
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Build-Depends:
 autotools-dev,
 cmake,
 debhelper (>= 9),
 libdisasm-dev,
 libpfm4-dev,
 zlib1g-dev,
# The following are required for the test suite
# python-pexpect,
# realpath
Standards-Version: 3.9.5
Homepage: http://rr-project.org
Vcs-Git: git://anonscm.debian.org/collab-maint/rr.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/rr.git;a=summary

Package: rr
Architecture: i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: application execution recorder, player and debugger
 rr allows application executions to be recorded and then replayed
 with gdb as many times as desired.
 .
 This allows intermittent, or complex to reproduce, bugs to be
 captured and then debugged at leisure. Replays are deterministic,
 always identical from one run to another.
 .
 rr is incompatible with ptrace hardening, and currently only supports
 Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge and Haswell CPUs.
