=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS += -O-Bbuild

override_dh_auto_configure:
	rm -f configure
	dh_auto_configure

override_dh_auto_test:
# Tests are disabled since they only work on supported CPUs
# (Intel Merom, Nehalem, Sandy Bridge and Ivy Bridge)

override_dh_auto_install:
	dh_auto_install
	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording

%:
	dh $@  --with autotools-dev
