=== debian/changelog ===
rr (3.0.0-1) experimental; urgency=medium

  * New upstream release, adding 64-bit and Broadwell support, uploaded to
    experimental for the Jessie freeze.
  * Add test-tmpdir.patch to support TMPDIR values other than /tmp.
  * Enforce building with cmake.
  * Standards-Version 3.9.6, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sat, 20 Dec 2014 18:05:05 +0100
