=== debian/control ===
--- 
+++ 
@@ -6,19 +6,21 @@
  autotools-dev,
  cmake,
  debhelper (>= 9),
+ gcc-multilib,
  libdisasm-dev,
  libpfm4-dev,
+ python,
  zlib1g-dev,
 # The following are required for the test suite
 # python-pexpect,
 # realpath
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://rr-project.org
 Vcs-Git: git://anonscm.debian.org/collab-maint/rr.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/rr.git;a=summary
 
 Package: rr
-Architecture: i386
+Architecture: amd64 i386
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
@@ -31,4 +33,5 @@
  always identical from one run to another.
  .
  rr is incompatible with ptrace hardening, and currently only supports
- Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge and Haswell CPUs.
+ Intel Nehalem, Westmere, Sandy Bridge, Ivy Bridge, Haswell and
+ Broadwell CPUs.
