=== debian/rules ===
--- 
+++ 
@@ -5,10 +5,6 @@
 #export DH_VERBOSE=1
 
 export DH_OPTIONS += -O-Bbuild
-
-override_dh_auto_configure:
-	rm -f configure
-	dh_auto_configure
 
 override_dh_auto_test:
 # Tests are disabled since they only work on supported CPUs
@@ -19,4 +15,4 @@
 	mv debian/rr/usr/bin/signal-rr-recording.sh debian/rr/usr/bin/signal-rr-recording
 
 %:
-	dh $@  --with autotools-dev
+	dh $@ --with autotools-dev --buildsystem=cmake
