## rr 3.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,14 +13,28 @@
 # debian is happy with it.  However, "_" is illegal in debs, while RPM
 # is cool with it.  Sigh.
 set(rr_VERSION_MAJOR 3)
-set(rr_VERSION_MINOR 0)
+set(rr_VERSION_MINOR 2)
 set(rr_VERSION_PATCH 0)
+
+add_definitions(-DRR_VERSION="${rr_VERSION_MAJOR}.${rr_VERSION_MINOR}.${rr_VERSION_PATCH}")
 
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pthread -O0 -g3 -Wall -Werror -Wstrict-prototypes")
 # Define __STDC_LIMIT_MACROS so |#include <stdint.h>| works as expected.
 # Define __STDC_FORMAT_MACROS so |#include <inttypes.h>| works as expected.
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D__USE_LARGEFILE64 -D__STDC_LIMIT_MACROS -D__STDC_FORMAT_MACROS -std=c++0x -pthread -O0 -g3 -Wall -Werror")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} -g3")
+
+# Check that a 32-bit cross-compile works. This is needed regardless
+# of whether the entire build is being built 32-bit.
+if(CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
+  # try_compile won't accept LINK_FLAGS, so do this manually.
+  file(WRITE "${CMAKE_BINARY_DIR}/test32.c" "int main() { return 0; }")
+  execute_process(COMMAND ${CMAKE_CXX_COMPILER} -o ${CMAKE_BINARY_DIR}/test32 ${CMAKE_BINARY_DIR}/test32.c -m32
+			RESULT_VARIABLE COMPILER_32BIT_RESULT)
+  if(NOT (COMPILER_32BIT_RESULT EQUAL 0))
+    message(FATAL_ERROR "Your toolchain doesn't support 32-bit cross-compilation.")
+  endif()
+endif()
 
 option(force32bit, "Force a 32-bit build, rather than a 64-bit one")
 if(force32bit)
@@ -39,6 +53,57 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${rr_MBITNESS_OPTION}")
 set(CMAKE_ASM_FLAGS "${CMAKE_ASM_FLAGS} ${rr_MBITNESS_OPTION}")
 
+find_package(PkgConfig REQUIRED)
+
+# If we're cross-compiling a 32-bit build on a 64-bit host we need
+# to ensure we're looking for the right libraries.
+# This has been tested on Ubuntu and Fedora.
+set(LIBDIR32_CANDIDATES
+  /usr/lib/i386-linux-gnu/pkgconfig/
+  /usr/lib/pkgconfig/
+)
+if((NOT rr_64BIT) AND CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
+  foreach(libdir ${LIBDIR32_CANDIDATES})
+    if(IS_DIRECTORY ${libdir})
+      set(ENV{PKG_CONFIG_LIBDIR} ${libdir})
+      break()
+     endif()
+   endforeach(libdir)
+   if (NOT DEFINED ENV{PKG_CONFIG_LIBDIR})
+     message(FATAL_ERROR "Couldn't find a suitable 32-bit pkgconfig lib dir. You probably need to install a 32-bit pkgconfig package (pkgconfig.i686 for Fedora or pkg-config:i386 for Ubuntu")
+   endif()
+endif()
+
+# Check for required libraries
+set(REQUIRED_LIBS
+  zlib
+)
+foreach(required_lib ${REQUIRED_LIBS})
+  string(TOUPPER ${required_lib} PKG)
+  pkg_check_modules(${PKG} REQUIRED ${required_lib})
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${${PKG}_CFLAGS}")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${${PKG}_CFLAGS}")
+endforeach(required_lib)
+
+# Check for Python >=2.7 but not Python 3.
+find_package(PythonInterp 2.7 REQUIRED)
+if(PYTHON_VERSION_MAJOR GREATER 2)
+  message(FATAL_ERROR "Python 3 is not supported, please use Python 2.7.")
+endif()
+
+# Check for required Python modules
+set(REQUIRED_PYTHON_MODULES
+  pexpect
+)
+foreach(py_module ${REQUIRED_PYTHON_MODULES})
+  execute_process(COMMAND "${PYTHON_EXECUTABLE}" "-c"
+			"import ${py_module}"
+			RESULT_VARIABLE module_status)
+  if(module_status)
+    message(FATAL_ERROR "Couldn't find required Python module ${py_module}.")
+  endif()
+endforeach(py_module)
+
 set_source_files_properties(src/preload/preload.c PROPERTIES COMPILE_FLAGS -O2)
 
 include_directories("${PROJECT_SOURCE_DIR}/include")
@@ -62,6 +127,8 @@
   SyscallDefsTable.generated
   SyscallEnumsX64.generated
   SyscallEnumsX86.generated
+  SyscallEnumsForTestsX64.generated
+  SyscallEnumsForTestsX86.generated
   SyscallHelperFunctions.generated
   SyscallnameArch.generated
   SyscallRecordCase.generated
@@ -71,15 +138,16 @@
   set_source_files_properties(${generated_file}
                               PROPERTIES GENERATED true HEADER_FILE_ONLY true)
   add_custom_command(OUTPUT ${generated_file}
-                     COMMAND python "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
+                     COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
 		               "${CMAKE_CURRENT_BINARY_DIR}/${generated_file}"
 		     DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/src/generate_syscalls.py"
 		       "${CMAKE_CURRENT_SOURCE_DIR}/src/syscalls.py"
 		       "${CMAKE_CURRENT_SOURCE_DIR}/src/assembly_templates.py")
 endforeach(generated_file)
 
+add_custom_target(Generated DEPENDS ${GENERATED_FILES})
+
 add_executable(rr
-  ${GENERATED_FILES}
   src/test/cpuid_loop.S
   src/AddressSpace.cc
   src/AutoRemoteSyscalls.cc
@@ -92,6 +160,8 @@
   src/EmuFs.cc
   src/Event.cc
   src/ExtraRegisters.cc
+  src/fast_forward.cc
+  src/FdTable.cc
   src/Flags.cc
   src/GdbConnection.cc
   src/GdbServer.cc
@@ -99,6 +169,7 @@
   src/kernel_abi.cc
   src/kernel_metadata.cc
   src/log.cc
+  src/MagicSaveDataMonitor.cc
   src/main.cc
   src/Monkeypatcher.cc
   src/PerfCounters.cc
@@ -111,18 +182,21 @@
   src/ReplayCommand.cc
   src/ReplaySession.cc
   src/replay_syscall.cc
+  src/ReplayTimeline.cc
   src/Scheduler.cc
   src/Session.cc
+  src/StdioMonitor.cc
   src/task.cc
   src/TraceFrame.cc
   src/TraceStream.cc
   src/util.cc
 )
+add_dependencies(rr Generated)
 
 target_link_libraries(rr
   -ldl
   -lrt
-  -lz
+  ${ZLIB_LDFLAGS}
 )
 
 target_link_libraries(rrpreload
@@ -198,6 +272,7 @@
   alarm
   alarm2
   async_segv_ignored
+  async_signal_syscalls2
   at_threadexit
   bad_ip
   bad_syscall
@@ -205,11 +280,16 @@
   big_buffers
   block
   blocked_sigsegv
+  brk
   chew_cpu
+  chown
   clock
   clone
+  clone_bad_stack
+  clone_untraced
   constructor
   desched_blocking_poll
+  dup
   epoll_create
   epoll_create1
   exec_self
@@ -221,6 +301,7 @@
   fork_stress
   fxregs
   getgroups
+  getrandom
   setitimer
   getsid
   gettimeofday
@@ -232,14 +313,17 @@
   int3
   intr_futex_wait_restart
   intr_poll
+  intr_pselect
   intr_read_no_restart
   intr_read_restart
   intr_sleep
   intr_sleep_no_restart
+  invalid_fcntl
   io
-  legacy-ugid
+  legacy_ugid
   madvise
   map_fixed
+  mincore
   mmap_discontinuous
   mmap_private
   mmap_ro
@@ -253,17 +337,35 @@
   mremap
   msg
   msync
+  multiple_pending_signals
+  multiple_pending_signals_sequential
+  munmap_segv
   munmap_discontinuous
   no_mask_timeslice
+  numa
+  old_fork
   orphan_process
   pause
   perf_event
   poll_sig_race
   prctl
+  prctl_deathsig
   prctl_name
   prw
   pthread_condvar_locking
+  ptrace
+  ptrace_attach_null_status
+  ptrace_attach_running
+  ptrace_attach_sleeping
+  ptrace_attach_stopped
+  ptrace_attach_thread_running
+  ptracer_death
+  ptracer_death_multithread
+  ptracer_death_multithread_peer
+  quotactl
   rdtsc
+  readdir
+  readlink
   readv
   rlimit
   rusage
@@ -272,25 +374,41 @@
   sched_yield
   sched_yield_to_lower_priority
   scm_rights
+  seccomp
+  seccomp_null
+  sem
   sendfile
+  set_ptracer
   setsid
+  shm
   sigaction_old
   sigaltstack
   sigchld_interrupt_signal
+  sighandler_fork
   sigill
   signalfd
   sigprocmask
   sigqueueinfo
   sigreturn
+  sigreturn_reg
   sigrt
+  sigstop
+  sigstop2
+  sigsuspend
   sigtrap
   simple
   sioc
+  sock_names_opts
   splice
   statfs
+  stdout_child
+  stdout_cloexec
+  stdout_dup
+  stdout_redirect
   strict_priorities
   switch_read
   syscallbuf_timeslice
+  syscallbuf_timeslice2
   sysconf
   sysctl
   sysemu_singlestep
@@ -302,11 +420,17 @@
   times
   tiocgwinsz
   truncate
+  tty_ioctls
   uname
   unjoined_thread
+  unshare
+  utimes
+  vfork_flush
+  video_capture
   wait
   write_race
   writev
+  xattr
   zero_length_read
 )
 
@@ -328,148 +452,21 @@
   async_signal_syscalls_siginfo
   async_usr1
   block_intr_sigchld
+  blocked_bad_ip
   breakpoint
   breakpoint_overlap
   call_function
+  checkpoint_dying_threads
+  clone_interruption
+  conditional_breakpoint_calls
   condvar_stress
   crash
   exit_group
   exit_status
   explicit_checkpoints
   fork_syscalls
+  function_calls
   getcwd
   goto_event
   hello
   ignored_async_usr1
-  immediate_restart
-  interrupt
-  intr_ptrace_decline
-  link
-  mmap_write
-  mutex_pi_stress
-  nanosleep
-  priority
-  ptrace
-  read_big_struct
-  restart_abnormal_exit
-  segfault
-  step_thread
-  target_fork
-  target_process
-  term_nonmain
-  threaded_syscall_spam
-  threads
-  tiocinq
-  user_ignore_sig
-  vfork
-  watchpoint
-)
-
-# A "test without program" is a foo.run driver script only, which does
-# something with one of the test executables above (or has special rules
-# to build its own executable).
-#
-# NB: you must update this variable when adding a new test source
-# file.  The list is not generated automatically.
-#
-# Alphabetical, please.
-set(TESTS_WITHOUT_PROGRAM
-  async_signal_syscalls_100
-  async_signal_syscalls_1000
-  bad_breakpoint
-  break_block
-  break_clock
-  break_clone
-  break_exec
-  break_int3
-  break_mmap_private
-  break_msg
-  break_rdtsc
-  break_sigreturn
-  break_sync_signal
-  break_thread
-  break_time_slice
-  call_exit
-  checkpoint_async_signal_syscalls_1000
-  checkpoint_mmap_shared
-  checkpoint_prctl_name
-  checkpoint_simple
-  cont_signal
-  cpuid
-  dead_thread_target
-  deliver_async_signal_during_syscalls
-  env_newline
-  execp
-  explicit_checkpoint_clone
-  fork_exec_info_thr
-  get_thread_list
-  hardlink_mmapped_files
-  parent_no_break_child_bkpt
-  parent_no_stop_child_crash
-  read_bad_mem
-  remove_watchpoint
-  restart_unstable
-  restart_diversion
-  sanity
-  signal_stop
-  signal_checkpoint
-  step1
-  step_rdtsc
-  step_signal
-  subprocess_exit_ends_session
-  syscallbuf_timeslice_250
-  trace_version
-  term_trace_cpu
-  term_trace_syscall
-)
-
-foreach(test ${BASIC_TESTS} ${TESTS_WITH_PROGRAM})
-  add_executable(${test} src/test/${test}.c)
-  target_link_libraries(${test} -lrt)
-endforeach(test)
-
-add_library(test_lib
-  src/test/test_lib.c
-)
-
-target_link_libraries(constructor -lrt test_lib)
-
-# cpuid test needs to link with cpuid_loop.S
-add_executable(cpuid src/test/cpuid.c src/test/cpuid_loop.S)
-target_link_libraries(cpuid -lrt)
-
-foreach(test ${BASIC_TESTS} ${OTHER_TESTS})
-  add_test(${test}
-    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -b ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-
-  add_test(${test}-no-syscallbuf
-    bash ${CMAKE_SOURCE_DIR}/src/test/basic_test.run -n ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}-no-syscallbuf
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-endforeach(test)
-
-foreach(test ${TESTS_WITH_PROGRAM} ${TESTS_WITHOUT_PROGRAM})
-  add_test(${test}
-    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -b ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-
-  add_test(${test}-no-syscallbuf
-    bash ${CMAKE_SOURCE_DIR}/src/test/${test}.run -n ${PROJECT_BINARY_DIR} ${test})
-  set_tests_properties(${test}-no-syscallbuf
-    PROPERTIES FAIL_REGULAR_EXPRESSION "FAILED")
-endforeach(test)
-
-# Run 32-bit tests on 64-bit builds.
-# We copy the test files into '32' subdirectories in the output
-# directory, so we can set different compile options on them.
-# This sucks but I can't find a better way to get CMake to build
-# the same source file in two different ways.
-if(rr_64BIT)
-  set_source_files_properties(32/rrutil.h
-                              PROPERTIES GENERATED true HEADER_FILE_ONLY true)
-  add_custom_command(OUTPUT 32/rrutil.h
-                     COMMAND mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/32 &&
-                             mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/bin/32 &&
