=== debian/changelog ===
rr (3.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Wed, 29 Apr 2015 20:32:57 +0200

rr (3.1.0-1) unstable; urgency=medium

  * New upstream release.
  * Drop test-tmpdir.patch, merged upstream.
  * Refresh move-librrpreload.patch.
  * g++-multilib, pkg-config and python-pexpect are now required.
  * setup.sh is no longer provided.

 -- Stephen Kitt <skitt@debian.org>  Sun, 26 Apr 2015 14:56:01 +0200
