=== debian/control ===
--- 
+++ 
@@ -6,13 +6,14 @@
  autotools-dev,
  cmake,
  debhelper (>= 9),
- gcc-multilib,
+ g++-multilib,
  libdisasm-dev,
  libpfm4-dev,
+ pkg-config,
  python,
+ python-pexpect,
  zlib1g-dev,
 # The following are required for the test suite
-# python-pexpect,
 # realpath
 Standards-Version: 3.9.6
 Homepage: http://rr-project.org
